package grpc

import (
	"context"
	"github.com/goccy/go-json"
	"google.golang.org/grpc"
	pb "htwkalender/common/genproto/modules"
	"htwkalender/ical/model"
	"log/slog"
	"time"
)

func GetFeed(feedId string, conn *grpc.ClientConn) (model.FeedRecord, error) {
	c := pb.NewFeedServiceClient(conn)
	ctx, cancel := context.WithTimeout(context.Background(), time.Second)
	defer cancel()

	r, err := c.GetFeed(ctx, &pb.GetFeedRequest{Id: feedId})
	if err != nil {
		slog.Error("could not get modules: %v", "error", err)
		return model.FeedRecord{}, err
	}

	feed, err := protoToFeed(r.GetFeed())
	if err != nil {
		slog.Error("could not convert feed: %v", "error", err)
		return model.FeedRecord{}, err
	}

	return feed, nil
}

func protoToFeed(feed *pb.Feed) (model.FeedRecord, error) {

	// unmarshal the []model.FeedModule from json
	var modules []model.FeedModule
	err := json.Unmarshal([]byte(feed.Modules), &modules)
	if err != nil {
		slog.Error("could not unmarshal modules: %v", "error", err)
		return model.FeedRecord{}, err
	}

	return model.FeedRecord{
		BaseModel: model.BaseModel{
			Id:      feed.Id,
			Created: model.ToJSONTime(feed.Created),
			Updated: model.ToJSONTime(feed.Updated),
		},
		Retrieved: model.ToJSONTime(feed.Retrieved),
		Modules:   modules,
	}, nil
}
